commit 1846c30223a60f1422c339f5c7e28d8a143526b0
Author: freddy77 <freddy77>
Date:   Wed Mar 3 08:08:56 2010 +0000

    compute length supporting all character sets

diff --git a/ChangeLog b/ChangeLog
index 59b0344..ca9f089 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Mar  3 09:08:14 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/write.c: compute length supporting all character sets
+
 Tue Mar  2 16:40:46 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c src/odbc/unittests/.cvsignore:
 	* src/odbc/unittests/Makefile.am src/odbc/unittests/common.h:
@@ -2359,4 +2362,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2998 2010/03/02 15:41:37 freddy77 Exp $
+$Id: ChangeLog,v 1.2999 2010/03/03 08:08:56 freddy77 Exp $
diff --git a/src/tds/write.c b/src/tds/write.c
index 1eb1d1a..57396d0 100644
--- a/src/tds/write.c
+++ b/src/tds/write.c
@@ -49,7 +49,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: write.c,v 1.78 2009/01/23 10:37:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: write.c,v 1.79 2010/03/03 08:08:57 freddy77 Exp $");
 
 /**
  * \addtogroup network
@@ -107,13 +107,19 @@ tds_put_string(TDSSOCKET * tds, const char *s, int len)
 	if (len < 0) {
 		if (client->min_bytes_per_char == 1) {	/* ascii or UTF-8 */
 			len = (int)strlen(s);
-		} else if (client->min_bytes_per_char == 2 && client->max_bytes_per_char == 2) {	/* UCS-2 or variant */
+		} else if (client->min_bytes_per_char == 2) {	/* UCS-2 or variant */
 			const char *p = s;
 
 			while (p[0] || p[1])
 				p += 2;
 			len = (int)(p - s);
 
+		} else if (client->min_bytes_per_char == 4) {	/* UCS-4 or variant */
+			const char *p = s;
+
+			while (p[0] || p[1] || p[2] || p[3])
+				p += 4;
+			len = (int)(p - s);
 		} else {
 			assert(client->min_bytes_per_char < 3);	/* FIXME */
 		}

